Installing on Hyper-V doesn't launch

Bug #942316 reported by Mike Sterling on 2012-02-27
26
This bug affects 4 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
High
Andy Whitcroft
ubiquity (Ubuntu)
Undecided
Unassigned

Bug Description

If I use a daily ISO build of precise using ISO's from 20120227 (ftp://cdimage.ubuntu.com/cdimage/daily-live/20120227/precise-desktop-i386.iso) on Windows Server Hyper-V, the VM never gets into the GUI for setup, and instead dumps me into a busybox shell.

Mike Sterling (mike-sterling) wrote :

I would have updated logs or other data, but /var/log doesn't exist - only /var/lock.

Mike Sterling (mike-sterling) wrote :

NOTE: This worked as of the Feb 16 ISO, but no longer works as of Feb 20 or later builds of Precise.

Mike Sterling (mike-sterling) wrote :

I did some further investigation into this. I downloaded the alternate ISO and it stopped at the "Detect and mount CD-ROM" step. I flipped to Alt-F2 and ran dmesg, comparing it against the precise-server ISO from the same date.

The server build successfully loaded the ISO 9660 extensions, but the alternate build had no such line.

Mike Sterling (mike-sterling) wrote :

What I thought was only a Client bug has also been confirmed on the Server builds as well. This is a complete blocker when attempting to deploy Precise on a Hyper-V VM.

Evan (ev) wrote :

Presumably you're in a "(initramfs)" shell? Does casper.log exist? Can you attach that to this bug report following the instructions in https://wiki.ubuntu.com/DebuggingCasper

Thanks!

Mike Sterling (mike-sterling) wrote :

Logs coming.

Mike Sterling (mike-sterling) wrote :

dmesg log

Mike Sterling (mike-sterling) wrote :

After reviewing this - I suspect the issue is the modifications to ata_piix to prevent it from loading on a Hyper-V platform. Since ata_piix now detects a Hyper-V platform and unloads if it's found, this would prevent the OS from installing. We need a modification to the patch here (http://people.canonical.com/~apw/lp929545-precise/0001-ata_piix-defer-to-the-Hyper-V-drivers-by-default.patch) that will only unload the block device handling, not the CD/DVD device handling.

Andy Whitcroft (apw) on 2012-03-06
Changed in ubiquity (Ubuntu):
assignee: nobody → Andy Whitcroft (apw)
importance: Undecided → High
status: New → In Progress
Changed in linux (Ubuntu):
status: New → In Progress
importance: Undecided → High
assignee: nobody → Andy Whitcroft (apw)
Changed in ubiquity (Ubuntu):
assignee: Andy Whitcroft (apw) → nobody
importance: High → Undecided
status: In Progress → New
Andy Whitcroft (apw) wrote :

@Mike -- are you saying that the hyper-v driver interface can only hand off the virtual hard disks but not handle the CD-rom device as well ?

Mike Sterling (mike-sterling) wrote :

Correct. We looked at adding code in hv_storvsc to handle CD/DVD devices, but decided against it as the duplication would be hellish to try to maintain.

Laurent Corrochano (loule) wrote :

Hi, i confirm that the CD-Rom is not handled once you've launched the install process and try to mount the device. Didn't try with burning the iso and capturing the physical drive in the guest.

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in ubiquity (Ubuntu):
status: New → Confirmed
Andy Whitcroft (apw) on 2012-03-08
Changed in ubiquity (Ubuntu):
status: Confirmed → Invalid
Andy Whitcroft (apw) wrote :

Ok confirmed that this is triggered by not being able to find the CDROM as root device during the install boot. This will need some support in ata_piix to prevent it taking the hard disks but allow it to take the cdrom devices. Patches are in testing.

Andy Whitcroft (apw) wrote :

Testing is good, patch now applied for the next upload.

Changed in linux (Ubuntu):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 3.2.0-18.29

---------------
linux (3.2.0-18.29) precise; urgency=low

  [ Andy Whitcroft ]

  * [Config] restore build-% shortcut
  * SAUCE: ata_piix: defer disks to the Hyper-V drivers by default
    - LP: #929545, #942316

  [ Eugeni Dodonov ]

  * SAUCE: drm: give up on edid retries when i2c bus is not responding
    - LP: #855124

  [ Seth Forshee ]

  * SAUCE: (drop after 3.3) platform/x86: Add driver for Apple gmux device
    - LP: #925544

  [ Upstream Kernel Changes ]

  * bsg: fix sysfs link remove warning
    - LP: #946928
  * regset: Prevent null pointer reference on readonly regsets
    - LP: #949905
    - CVE-2012-1097
  * regset: Return -EFAULT, not -EIO, on host-side memory fault
    - LP: #949905
    - CVE-2012-1097

  [ Wu Fengguang ]

  * SAUCE: (drop after 3.4) ALSA: hda - add id for Atom Cedar Trail HDMI
    codec
 -- Leann Ogasawara <email address hidden> Fri, 09 Mar 2012 07:56:11 -0800

Changed in linux (Ubuntu):
status: Fix Committed → Fix Released

For those using 12.04 beta1 on Hyper-V, a workaround to the CD-ROM bug above (until beta 2 comes out) is to boot the initial installer with an additional kernel flag to not switch to using the Hyper-V IDE drivers. The boot flags can be viewed by pressing F5? F6? (one of those) on the setup boot screen and then navigating to the boot line with cursor keys and adding the boot parameter below before the double dash at the end of the line.

The flag to disable the Hyper-V IDE drivers is:

 ata_piix.prefer_ms_hyperv=0

The CD-ROM install then proceeds as usual.

Regards,
Tim Miller Dyck

Victor Miasnikov (vvm) wrote :

> 12.04 beta1 on Hyper-V

 Yes, not work as need without ata_piix.prefer_ms_hyperv=0 in boot parametrs

But

 See
http://vvm.blog.tut.by/2012/03/29/linux-on-hyper-v-use-hv_storvsc-instead-of-ata_piix-to-handle-the-ide-disks-devices-but-not-for-the-dvd-rom-cd-rom-device-handling/

 Or

http://marc.info/?l=linux-kernel&m=133302969709312&w=2
==
List: linux-kernel
Subject: Linux on Hyper-V -- use hv_storvsc instead of ata_piix to handle the IDE disks devices ( but not for the DVD-ROM / CD-ROM device handling) Fw: [PATCH RFC] ata_piix: ignore disks in a hyper-v guest
From: "Victor Miasnikov"
Date: 2012-03-29 14:00:05

 . . .

"UBUNTU Way" Solution -- tested with
Ubuntu 12.04 LTS (Precise Pangolin) Daily Build 2012-03-13
precise-desktop-amd64.iso
, work Ok
 . . .
==

Victor Miasnikov (vvm) wrote :

I.e. after

Ubuntu 12.04 LTS (Precise Pangolin) Daily Build 2012-03-13
 precise-desktop-amd64.iso

this issue fixed

Victor Miasnikov (vvm) wrote :

Mike Sterling (mike-sterling) wrote on 2012-03-05:
==
After reviewing this - I suspect the issue is the modifications to ata_piix to prevent it from loading on a Hyper-V platform. Since ata_piix now detects a Hyper-V platform and unloads if it's found, this would prevent the OS from installing. We need a modification to the patch here ( VVM: only for history :-) . . ./lp929545-precise/0001-ata_piix-defer-to-the-Hyper-V-drivers-by-default.patch ) that will only unload the block device handling, not the CD/DVD device handling.
==

 Done: 1) in Ubuntu kernel already 2) for "vanila kernel" send patch ( Big thanks Andy Whitcroft (apw)! ) see
http://marc.info/?l=linux-kernel&m=133304222215301&w=2
==
List: linux-kernel
Subject: [PATCH 1/1] ata_piix: defer disks to the Hyper-V paravirtualised drivers by default
From: Andy Whitcroft <apw () canonical ! com>
Date: 2012-03-29 17:28:50

When we are hosted on a Hyper-V hypervisor the guest disks are exposed
both via the Hyper-V paravirtualised drivers and via an emulated SATA disk
controller. We want to use the paravirtualised drivers where possible as
they are much more performant. The Hyper-V paravirtualised drivers only
expose the virtual hard disk devices, the CDROM/DVD devices must still
be enumerated on the virtualised SATA controller. As we have no control
over kernel probe order for these two drivers especially when one driver
is builtin to the kernel and the other a module, we need to prevent the
ata_piix driver from claiming the disks devices by default when running
on a Hyper-V hypervisor.

When enumerating the drives look at the aquired device ID and if it
appears to be a disk device then report it as disconnected. Limit this
behaviour to when we have detected a Hyper-V hypervisor. Finally allow
this behaviour to be overriden via a new module parameter.

==

Victor Miasnikov (vvm) wrote :

Please, fix this issue:

http://www.yusufozturk.info/linux-server/future-of-linux-support-ubuntu-12-on-hyper-v-v3.html
==
  . . .
4. Unfortunately, there is no KVP service with Ubuntu 12. (I used Set-LinuxVM for KVP test)
  . . .
==

IMHO, need backport this:

2012-03-16 K. Y. Srinivasan

Tools: hv: Fully support the new KVP verbs in the user...
...messages in the user level daemon. Hyper-V defines

2012-03-13 K. Y. Srinivasan

Drivers: hv: Add new message types to enhance KVP
 ...functionality for Linux guests on Hyper-V. As part of this,

and other from 3.4-rc1

Victor Miasnikov (vvm) wrote :

----- Original Message -----
From: "Mike Sterling" mike.sterling (at) microsoft (.) com
To: vvm
Sent: Tuesday, April 03, 2012 5:59 PM

This fix has been checked in to Ubuntu 12.04, and should be available to test in the daily ISO's next week.

--

  Very well!

 Thanks!

Martin (martin1140) wrote :

Just downloaded Ubuntu 12.04 LTS final version.

While the beginning of the installation process on Hyper-V ubuntu fails to mount cd-rom drive!
Hyper-V is 2008r2 with all patches within a cluster. no installation possible; trying known workaround...

is it a feature? ;)

regards,
martin

Martin (martin1140) wrote :

ok,

ata_piix.prefer_ms_hyperv=0

still working....

tipp: press f3 and select keymap, press f6, press escape, go bevore "--" at the end and type, after that just hit enter.

but still....some really anoying bug!

regards

Mike Sterling (mike-sterling) wrote :

This should be fixed in 12.04 RTM. What is the checksum of the ISO you're using? Once I get a stable internet connection, I'll try this out with a new ISO download.

Martin (martin1140) wrote :

RTM? Thought 12.04 is RTM as "beta" was removed from ubuntu.com?

I downloaded yesterday: http://www.ubuntu.com/download/server/thank-you?distro=server&release=lts&bits=64

regards

Mike Sterling (mike-sterling) wrote :

I downloaded the ISO from the URL you mentioned, and was able to successfully install from it. Can you confirm that the MD5SUM matches the sum here?

https://help.ubuntu.com/community/UbuntuHashes

I used the windows tool md5summer to confirm the hash.

Martin (martin1140) wrote :

@Mike: Thanks for testing.

Just downloaded the ISO again - now everything is fine.

Seems a mirror was not properly updated!

Great! hope to have a very stable ubuntu on hyper-v now! ;)

ray1214 (lieyanfengbao) wrote :

Samsung is always very fast to meet user demand for the popular Samsung GALAXY S3 smartphone and GALAXY NOTE 10.1 Tablet PC, users generally want to upgrade to Android 4.1 Jelly Bean, of course, Samsung also attaches great importance to the user upgrade needsSamsung recently to the user during the General Assembly in IFA2012 eat teeth reassurance Samsung official said, GALAXY S3, and the GALAXY NOTE 10.1 <a href="http://www.no1rayban.com/">Ray Ban</a>users will upgrade to the android 4.1 in the near specific upgrade date yet to be announced.

I cannot get Ubuntu Server 12.04.1 LTS to install in Hyper-V.
I downloaded the http://releases.ubuntu.com/precise version:
ubuntu-12.04.1-server-amd64.iso 17-Aug-2012 22:15 657M Server install CD for 64-bit PC (AMD64) computers (standard download)
I have tried every F6: ata_piix.prefer_ms_hyperv=0 and reserve=0x1f0,0x8 combinations described as work arounds, but I still cannot get passed this issue.

If the workaround worked at one time, it does not seem to be working now. What is the progress for fixing this or providing a working work around?

Referring to my previous post: The F6: ... -- ata_piix.prefer_ms_hyperv=0 work around Worked after I installed Windows Server 2008 R2 SP1.

Luis Henriques (henrix) wrote :

This bug is awaiting verification that the kernel for Precise in -proposed solves the problem (3.2.0-35.55). Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-precise' to 'verification-done-precise'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-precise
Victor Miasnikov (vvm) wrote :

> kernel for Precise 3.2.0-35.55

I did not tested it yet

 But this:
Ubuntu 13.04 "raring" - amd64 06-Dec-2012 16:33
http://archive.ubuntu.com/ubuntu/dists/raring/main/installer-amd64/current/images/netboot/mini.iso

 need use boot parameter
reserve=0x1f0,0x8

 Without this install wizard stop working imm. before select disk partitioning step

Luis Henriques (henrix) wrote :

As per an IRC chat with Ben Howard he has verified this issue is fixed. Thus, I'm tagging this as verified in Precise.

tags: added: verification-done-precise
removed: verification-needed-precise

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers